% Example-09: Producers - Consumers problem
%   Solution based on "Colored Petri Net" 
% Reggie.davidrajuh@uis.no  (c) 15 Nov 2017

function [fire, transition] = COMMON_PRE (transition)

switch transition.name
    case 'P1'  % P1 adds color "P1-to-C1" to tokens 
        transition.new_color = 'P1-to-C1';
        fire = 1;
        
    case 'P2'  % P2 adds color "P2-to-C2" to tokens 
        transition.new_color = 'P2-to-C2';
        fire = 1;
        
    case 'tTransport' % tTransport prefers P1. If no P1, then takes P2
        tokID1 = tokenAnyColor ('pMixedBuff', 1, {'P1-to-C1'});
        transition.selected_tokens = tokID1;    % tokens to be removed
        fire = 1; % ONLY in case of NO P1, take P2

    case 'tFilt1' % tFilt1 selects P2 tokens only from pReceived
        tokID1 = tokenAnyColor ('pReceived', 1, {'P1-to-C1'});
        transition.selected_tokens = tokID1;    % tokens to be removed
        fire = tokID1; % fire ONLY if P1 found

    case 'tFilt2' % tFilt2 selects P2 tokens only from pReceived
        tokID2 = tokenAnyColor ('pReceived', 1, {'P2-to-C2'});
        transition.selected_tokens = tokID2;    % tokens to be removed
        fire = tokID2; % fire ONLY if P2 found        

    otherwise
        % just fire, in case of tMix1 and tMix2
        fire = 1;
end
