% Sample code from the book: "Colored Petri Nets for 
% Modeling of Discrete Systems: A practical approach with GPenSIM"
% 
% Example-09: Producers - Consumers Problem
%   Solution based on "Colored Petri Net" 
% Reggie.davidrajuh@uis.no  (c) 15 Nov 2017

clear all; clc;
global global_info
global_info.STOP_AT = 70; 

png = pnstruct('producer_consumer_pdf');

%%%% DYNAMIC DETAILS %%%%
dyn.m0 = {'pStart1',3, 'pStart2',3};
dyn.ft = {'tTransport',10, 'allothers',1};    
pni = initialdynamics(png,dyn);

sim = gpensim(pni);
plotp(sim, {'C1','C2'});
prncolormap(sim);
prnfinalcolors(sim);

